package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLMap_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLMap extends JNIObject implements IISLSingleSpaceMapMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLMap(long ptr) {
		/*** PROTECTED REGION ID(ISLMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLMap build(long ptr) {
		return new ISLMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLMap_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public ISLSet getDomain() {
		return copy().domain();
	}
	
	public ISLSet getRange() {
		return copy().range();
	}
	
	public ISLMap getDomainMap() {
		return copy().domainMap();
	}
	
	public ISLMap getRangeMap() {
		return copy().rangeMap();
	}

	/***
	 * Converts ISLMap to ISLSet with equivalent constraints, but without the distinction of inputs/outputs.
	 * 
	 * @return
	 */
	public ISLSet toSet() {
		return this.moveDims(ISLDimType.isl_dim_in, getNbInputs(), ISLDimType.isl_dim_out, 0, getNbOutputs()).getDomain();
	}

	public List<ISLBasicMap> getBasicMaps() {
		List<ISLBasicMap> res = new ArrayList<ISLBasicMap>();
		for (int i = 0; i < getNbBasicMaps(); i++) {
			res.add(getBasicMapAt(i));
		}
		return res;
	}

	public ISLMap power(long pow) {
		return power(ISLVal.buildFromLong(getContext(), pow));
	}
	
	public ISLMap parametricPower() {
		JNIPtrBoolean val = new JNIPtrBoolean();
		return parametricPower(val);
	}
	
	public ISLMap reachingPathLengths() {
		JNIPtrBoolean val = new JNIPtrBoolean();
		return reachingPathLengths(val);
	}

	/**
	 * Try to combine 2 closed form relations into one.
	 * 
	 * @param e1
	 * @param e2
	 * @return the combination if it is possible to combine both arguments. null
	 *         otherwise.
	 */
	private static Entry<ISLSet, ISLMultiAff> combine(
			Entry<ISLSet, ISLMultiAff> e1,
			Entry<ISLSet, ISLMultiAff> e2) {
		ISLMultiAff expr1 = e1.getValue();
		ISLSet set1 = e1.getKey();
		ISLMultiAff expr2 = e2.getValue();
		ISLSet set2 = e2.getKey();

		//first make sure that the inputs are compatible
		if (expr1.getNbOutputs() != expr2.getNbOutputs()
				|| !set1.getSpace().isEqual(set2.getSpace()))
			throw new RuntimeException();

		ISLSet union = set1.copy().union(set2.copy());

		//if the 2 expressions are equivalent, combine them.
		if (expr1 == expr2 || expr1.isPlainEqual(expr2))
			return new AbstractMap.SimpleEntry<ISLSet, ISLMultiAff>(union.simplify(), expr1);

		ISLMap mapFunc1 = expr1.copy().toBasicMap().toMap();
		ISLMap map1 = mapFunc1.copy().intersectDomain(set1.copy());
		ISLMap mapFunc2 = expr2.copy().toBasicMap().toMap();
		ISLMap map2 = mapFunc2.copy().intersectDomain(set2.copy());
		ISLMap mapUnion = map2.copy().union(map1.copy());
		ISLSpace mapSpace = mapUnion.getSpace();

		// try different combinations of expressions and domains in order to
		// find one equivalent
		ISLMap map21 = mapFunc1.intersectDomain(set2.copy());
		if (map21.isEqual(map2))
			return null;//new AbstractMap.SimpleEntry<JNIISLMultiAff, JNIISLSet>(expr1, union);

		ISLMap map12 = mapFunc2.intersectDomain(set1.copy());
		if (map12.isEqual(map1))
			return new AbstractMap.SimpleEntry<ISLSet, ISLMultiAff>(union.simplify(), expr2);

		ISLMap func1 = expr1.copy().toBasicMap().toMap();
		func1 = func1.intersectDomain(union.copy());
		if (func1.isEqual(mapUnion.copy()))
			return new AbstractMap.SimpleEntry<ISLSet, ISLMultiAff>(union.simplify(), expr1);

		ISLMap func2 = expr2.copy().toBasicMap().toMap();
		func2 = func2.intersectDomain(union.copy());
		if (func2.isEqual(mapUnion.copy()))
			return new AbstractMap.SimpleEntry<ISLSet, ISLMultiAff>(union.simplify(), expr2);

		// if the number of dimensions from the input (of the map) differs from
		// the output, stop here (return null).
		if (expr1.getNbOutputs() != set1.getNbIndices())
			return null;

		// else try to replace some dimensions with constants (in order to fix
		// some ISL artifacts)
		ISLMultiAff tCopy = expr1.copy();
		List<ISLAff> tAffs = tCopy.getAffs();
		for (int i = 0; i < mapSpace.dim(ISLDimType.isl_dim_out); i++) {
			ISLBasicMap tbm1 = ISLBasicMap.buildUniverse(mapSpace.copy());
			ISLBasicMap tbm2 = ISLBasicMap.buildUniverse(mapSpace.copy());
			for (int j = 0; j <= i; j++)
				if (tAffs.get(j).isConstant())
					tbm2 = tbm2.addConstraint(ISLConstraint.dimEqual(mapSpace.copy(), j));
				else
					tbm1 = tbm1.addConstraint(ISLConstraint.dimEqual(mapSpace.copy(), j));
			for (int j = i + 1; j < mapSpace.dim(ISLDimType.isl_dim_out); j++)
				tbm1 = tbm1.addConstraint(ISLConstraint.dimEqual(mapSpace.copy(), j));
			ISLBasicMap omg = tCopy.copy().toBasicMap().applyRange(tbm1).intersect(tbm2);
			func1 = omg.copy().toMap().intersectDomain(
					union.copy());
			if (func1.isEqual(mapUnion.copy())) {
				ISLMultiAff mergedValue = omg.getClosedFormRelation()
						.values().iterator().next();
				return new AbstractMap.SimpleEntry<ISLSet, ISLMultiAff>(
						union.simplify(), mergedValue);
			}
		}

		return null;
	}

	/**
	 * This method computes the closed form expressions of a relation. For
	 * example, given "{[i] -> [j] : 0 <= i < 8 && i = j + 8}", the result is a
	 * map with single entry containing the expression of "j" given "i" : "i-8",
	 * and its validity domain : "{[i] : 0 <= i < 8}". <br/>
	 * IMPORTANT : this methods compute the expressions using the lexmin
	 * algorithm. If the lexmax is expected, first apply the lexmax on the
	 * relation, and then call this method.
	 * 
	 * @return Map containing the closed form expressions of the relation, and
	 *         their associated validity domains.
	 */
	public Map<ISLSet, ISLMultiAff> getClosedFormRelation() {
		if (!this.isSingleValued())
			throw new RuntimeException(this + " is not single valued.");

		//compute the closed form
		Map<ISLSet, ISLMultiAff> tmp = new LinkedHashMap<ISLSet, ISLMultiAff>();
		List<ISLBasicMap> basicMaps = getBasicMaps();
		for (ISLBasicMap bmap : basicMaps) {
			Map<ISLSet, ISLMultiAff> res = bmap.getClosedFormRelation();
			for (Entry<ISLSet, ISLMultiAff> e : res.entrySet()) {
				ISLMultiAff value = e.getValue();
				ISLSet validityDomain = e.getKey();
				tmp.put(validityDomain.simplify(), value);
			}
		}

		//try to reduce the number of expressions
		List<Entry<ISLSet, ISLMultiAff>> l1 = new ArrayList<Map.Entry<ISLSet, ISLMultiAff>>(tmp.entrySet());
		main : for (int i = 0; i < l1.size(); i++) {
			Entry<ISLSet, ISLMultiAff> current = l1.get(i);
			for (int j = i + 1; j < l1.size(); j++) {
				if (i == j)
					continue;
				Entry<ISLSet, ISLMultiAff> combine = combine(current, l1.get(j));
				if (combine != null) {
					l1.remove(j);
					l1.remove(i);
					l1.add(combine);
					i--;
					continue main;
				}
			}
		}

		// convert list to map 
		// no gist at this point, no need to keep any order
		// although we keep order for deterministic executions
		Map<ISLSet, ISLMultiAff> res = new LinkedHashMap<ISLSet, ISLMultiAff>();
		for (Entry<ISLSet, ISLMultiAff> e : l1)
			res.put(e.getKey(), e.getValue());
		return res;
	}

	public ISLMap simplify() {
		return detectEqualities().coalesce();
	}

	public static ISLMap lexEQFirst(ISLSpace dim, long n) {
		ISLBasicMap bmap = ISLBasicMap.buildUniverse(dim.copy());

		for (int i = 0; i < n; i++) {
			ISLConstraint c = ISLConstraint.buildEquality(dim.copy().toLocalSpace());
			c = c.setConstant(0);
			c = c.setCoefficient(ISLDimType.isl_dim_in, i, 1);
			c = c.setCoefficient(ISLDimType.isl_dim_out, i, -1);
			bmap = bmap.addConstraint(c);
		}

		return bmap.toMap();
	}

	//FIXME see JNIISLMap.identity(JNIISLSpace set_dim)
	public static ISLMap lexEQ(ISLSpace dimSet) {
		int n = (int) dimSet.dim(ISLDimType.isl_dim_set);
		ISLSpace dim = ISLSpace.idMapDimFromSetDim(dimSet.copy());
		ISLBasicMap bmap = ISLBasicMap.buildUniverse(dim.copy());
		for (int i = 0; i < n; i++) {
			ISLConstraint c = ISLConstraint.buildEquality(dim.copy().toLocalSpace());
			c = c.setConstant(0);
			c = c.setCoefficient(ISLDimType.isl_dim_in, i, 1);
			c = c.setCoefficient(ISLDimType.isl_dim_out, i, -1);
			bmap = bmap.addConstraint(c);
		}
		return bmap.toMap();
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_map_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLMap buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_map_read_from_str) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.isl_map_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMap buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_map_empty) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMap.build(ISLNative.isl_map_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMap buildUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_map_universe) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMap.build(ISLNative.isl_map_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_nat_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMap buildNonNegUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_map_nat_universe) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMap.build(ISLNative.isl_map_nat_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_identity 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMap buildIdentity(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_map_identity) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMap.build(ISLNative.isl_map_identity(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_domain 
	 * 
	@take set
	 * @generated
	**/
	 public static ISLMap buildFromDomain(ISLSet set) { 
		/*** PROTECTED REGION ID(static_isl_map_from_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_domain(getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_range 
	 * 
	@take set
	 * @generated
	**/
	 public static ISLMap buildFromRange(ISLSet set) { 
		/*** PROTECTED REGION ID(static_isl_map_from_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_range(getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_domain_and_range 
	 * 
	@take domain range
	 * @generated
	**/
	 public static ISLMap buildFromDomainAndRange(ISLSet domain, ISLSet range) { 
		/*** PROTECTED REGION ID(static_isl_map_from_domain_and_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(domain, range);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_domain_and_range(getNativePtr(domain), getNativePtr(range)));
			} finally {
				taken(domain);
				taken(range);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLMap map, int format) { 
		/*** PROTECTED REGION ID(static_isl_map_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_to_string(getNativePtr(map), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_map_from_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap toUnionMap() {
		/*** PROTECTED REGION ID(isl_union_map_from_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_from_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff toPWMultiAff() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_from_map) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_from_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_map_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_map_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_map_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_map_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_copy 
	 * 
	 * @generated
	**/
	public ISLMap copy() {
		/*** PROTECTED REGION ID(isl_map_copy) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.isl_map_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_map_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_map_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_add_constraint 
	 * 
	 * @take this constraint
	 * @generated
	**/
	public ISLMap addConstraint(ISLConstraint constraint) {
		/*** PROTECTED REGION ID(isl_map_add_constraint) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, constraint);
			try {
				res = ISLMap.build(ISLNative.isl_map_add_constraint(getNativePtr(this), getNativePtr(constraint)));
			} finally {
				taken(this);
				taken(constraint);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_make_disjoint 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap makeDisjoint() {
		/*** PROTECTED REGION ID(isl_map_make_disjoint) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_make_disjoint(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_compute_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap computeDivs() {
		/*** PROTECTED REGION ID(isl_map_compute_divs) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_compute_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_remove_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap removeDivs() {
		/*** PROTECTED REGION ID(isl_map_remove_divs) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_remove_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_remove_unknown_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap removeUnknownDivs() {
		/*** PROTECTED REGION ID(isl_map_remove_unknown_divs) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_remove_unknown_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_remove_divs_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap removeDivsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_map_remove_divs_involving_dims) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_remove_divs_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_map_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_map_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap setTupleName(ISLDimType type, String s) {
		/*** PROTECTED REGION ID(isl_map_set_tuple_name) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_set_tuple_name(getNativePtr(this), type.getValue(), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_map_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_map_set_dim_name) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_has_tuple_name 
	 * 
	 * @generated
	**/
	public boolean hasTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_map_has_tuple_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_has_tuple_name(getNativePtr(this), type.getValue()) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_has_dim_name 
	 * 
	 * @generated
	**/
	public boolean hasDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_map_has_dim_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_has_dim_name(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findDimByName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_map_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_map_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_map_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_bijective 
	 * 
	 * @generated
	**/
	public boolean isBijective() {
		/*** PROTECTED REGION ID(isl_map_is_bijective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_bijective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_injective 
	 * 
	 * @generated
	**/
	public boolean isInjective() {
		/*** PROTECTED REGION ID(isl_map_is_injective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_injective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_single_valued 
	 * 
	 * @generated
	**/
	public boolean isSingleValued() {
		/*** PROTECTED REGION ID(isl_map_is_single_valued) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_single_valued(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_domain_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean domainIsWrapping() {
		/*** PROTECTED REGION ID(isl_map_domain_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_domain_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_range_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean rangeIsWrapping() {
		/*** PROTECTED REGION ID(isl_map_range_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_range_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_can_curry 
	 * 
	 * @generated
	**/
	public boolean canCurry() {
		/*** PROTECTED REGION ID(isl_map_can_curry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_can_curry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_can_uncurry 
	 * 
	 * @generated
	**/
	public boolean canUncurry() {
		/*** PROTECTED REGION ID(isl_map_can_uncurry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_can_uncurry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_can_range_curry 
	 * 
	 * @generated
	**/
	public boolean canRangeUncurry() {
		/*** PROTECTED REGION ID(isl_map_can_range_curry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_can_range_curry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_can_zip 
	 * 
	 * @generated
	**/
	public boolean canZip() {
		/*** PROTECTED REGION ID(isl_map_can_zip) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_can_zip(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_product 
	 * 
	 * @generated
	**/
	public boolean isProduct() {
		/*** PROTECTED REGION ID(isl_map_is_product) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_product(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_plain_is_empty 
	 * 
	 * @generated
	**/
	public boolean isPlainEmpty() {
		/*** PROTECTED REGION ID(isl_map_plain_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_plain_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_plain_is_injective 
	 * 
	 * @generated
	**/
	public boolean isPlainInjective() {
		/*** PROTECTED REGION ID(isl_map_plain_is_injective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_plain_is_injective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_plain_is_single_valued 
	 * 
	 * @generated
	**/
	public boolean isPlainSingleValued() {
		/*** PROTECTED REGION ID(isl_map_plain_is_single_valued) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_plain_is_single_valued(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_equal(getNativePtr(this), getNativePtr(map2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isDisjoint(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_disjoint(getNativePtr(this), getNativePtr(map2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_subset(getNativePtr(this), getNativePtr(map2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_is_strict_subset 
	 * 
	 * @generated
	**/
	public boolean isStrictSubset(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_is_strict_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_is_strict_subset(getNativePtr(this), getNativePtr(map2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_plain_is_equal(getNativePtr(this), getNativePtr(map2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet params() {
		/*** PROTECTED REGION ID(isl_map_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_map_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_complement 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap complement() {
		/*** PROTECTED REGION ID(isl_map_complement) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_complement(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_reverse 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap reverse() {
		/*** PROTECTED REGION ID(isl_map_reverse) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_reverse(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_map_project_out) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet domain() {
		/*** PROTECTED REGION ID(isl_map_domain) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_map_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet range() {
		/*** PROTECTED REGION ID(isl_map_range) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_map_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap domainMap() {
		/*** PROTECTED REGION ID(isl_map_domain_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_range_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap rangeMap() {
		/*** PROTECTED REGION ID(isl_map_range_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_range_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_eliminate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap eliminate(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_map_eliminate) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_eliminate(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_fix_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceFixed(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_map_fix_si) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_fix_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_fix_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMap sliceFixed(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_map_fix_val) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMap.build(ISLNative.isl_map_fix_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lower_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceLB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_map_lower_bound_si) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lower_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_upper_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceUB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_map_upper_bound_si) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_upper_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_equate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceEquate(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_equate) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_equate(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_oppose 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceOppose(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_oppose) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_oppose(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_order_ge 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceGE(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_order_ge) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_order_ge(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_order_gt 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceGT(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_order_gt) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_order_gt(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_order_le 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceLE(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_order_le) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_order_le(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_order_lt 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap sliceLT(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_map_order_lt) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_order_lt(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_deltas 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet deltas() {
		/*** PROTECTED REGION ID(isl_map_deltas) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_map_deltas(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_deltas_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap deltasMap() {
		/*** PROTECTED REGION ID(isl_map_deltas_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_deltas_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap coalesce() {
		/*** PROTECTED REGION ID(isl_map_coalesce) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap detectEqualities() {
		/*** PROTECTED REGION ID(isl_map_detect_equalities) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_remove_redundancies 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap removeRedundancies() {
		/*** PROTECTED REGION ID(isl_map_remove_redundancies) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_remove_redundancies(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_convex_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap convexHull() {
		/*** PROTECTED REGION ID(isl_map_convex_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_convex_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap affineHull() {
		/*** PROTECTED REGION ID(isl_map_affine_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_polyhedral_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap polyhedralHull() {
		/*** PROTECTED REGION ID(isl_map_polyhedral_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_polyhedral_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_simple_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap simpleHull() {
		/*** PROTECTED REGION ID(isl_map_simple_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_simple_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_unshifted_simple_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap unshiftedSimpleHull() {
		/*** PROTECTED REGION ID(isl_map_unshifted_simple_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_unshifted_simple_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_drop_constraints_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap dropConstraintsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_map_drop_constraints_involving_dims) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_drop_constraints_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_sample 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sample() {
		/*** PROTECTED REGION ID(isl_map_sample) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_sample(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_fixed_power_val 
	 * 
	 * @take this exp
	 * @generated
	**/
	public ISLMap power(ISLVal exp) {
		/*** PROTECTED REGION ID(isl_map_fixed_power_val) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, exp);
			try {
				res = ISLMap.build(ISLNative.isl_map_fixed_power_val(getNativePtr(this), getNativePtr(exp)));
			} finally {
				taken(this);
				taken(exp);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_power 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap parametricPower(JNIPtrBoolean exact) {
		/*** PROTECTED REGION ID(isl_map_power) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_power(getNativePtr(this), exact));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_transitive_closure 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap transitiveClosure(JNIPtrBoolean exact) {
		/*** PROTECTED REGION ID(isl_map_transitive_closure) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_transitive_closure(getNativePtr(this), exact));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_reaching_path_lengths 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap reachingPathLengths(JNIPtrBoolean exact) {
		/*** PROTECTED REGION ID(isl_map_reaching_path_lengths) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_reaching_path_lengths(getNativePtr(this), exact));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_wrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet wrap() {
		/*** PROTECTED REGION ID(isl_map_wrap) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_map_wrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_flatten 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap flatten() {
		/*** PROTECTED REGION ID(isl_map_flatten) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_flatten(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_flatten_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap flattenDomain() {
		/*** PROTECTED REGION ID(isl_map_flatten_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_flatten_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_flatten_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap flattenRange() {
		/*** PROTECTED REGION ID(isl_map_flatten_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_flatten_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_zip 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap zip() {
		/*** PROTECTED REGION ID(isl_map_zip) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_zip(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap curry() {
		/*** PROTECTED REGION ID(isl_map_curry) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_uncurry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap uncurry() {
		/*** PROTECTED REGION ID(isl_map_uncurry) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_uncurry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_range_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap rangeCurry() {
		/*** PROTECTED REGION ID(isl_map_range_curry) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_range_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLMap alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_map_align_params) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLMap.build(ISLNative.isl_map_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_map_add_dims) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap insertDims(ISLDimType type, int pos, int n) {
		/*** PROTECTED REGION ID(isl_map_insert_dims) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_insert_dims(getNativePtr(this), type.getValue(), pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_map_move_dims) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_intersect_params 
	 * 
	 * @take this params
	 * @generated
	**/
	public ISLMap intersectParams(ISLSet params) {
		/*** PROTECTED REGION ID(isl_map_intersect_params) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, params);
			try {
				res = ISLMap.build(ISLNative.isl_map_intersect_params(getNativePtr(this), getNativePtr(params)));
			} finally {
				taken(this);
				taken(params);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_intersect_domain 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLMap intersectDomain(ISLSet set) {
		/*** PROTECTED REGION ID(isl_map_intersect_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLMap.build(ISLNative.isl_map_intersect_domain(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_intersect_range 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLMap intersectRange(ISLSet set) {
		/*** PROTECTED REGION ID(isl_map_intersect_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLMap.build(ISLNative.isl_map_intersect_range(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_intersect 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap intersect(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_intersect) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_intersect(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_union 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap union(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_union) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_union(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_subtract 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap subtract(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_subtract) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_subtract(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_subtract_domain 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap subtractDomain(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_map_subtract_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_map_subtract_domain(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_subtract_range 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap subtractRange(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_map_subtract_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_map_subtract_range(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_apply_domain 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap applyDomain(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_apply_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_apply_domain(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_apply_range 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap applyRange(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_apply_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_apply_range(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_preimage_domain_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLMap preimageDomain(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_map_preimage_domain_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLMap.build(ISLNative.isl_map_preimage_domain_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_preimage_domain_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLMap preimageDomain(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_map_preimage_domain_pw_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLMap.build(ISLNative.isl_map_preimage_domain_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_preimage_domain_multi_pw_aff 
	 * 
	 * @take this mpa
	 * @generated
	**/
	public ISLMap preimageDomain(ISLMultiPWAff mpa) {
		/*** PROTECTED REGION ID(isl_map_preimage_domain_multi_pw_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, mpa);
			try {
				res = ISLMap.build(ISLNative.isl_map_preimage_domain_multi_pw_aff(getNativePtr(this), getNativePtr(mpa)));
			} finally {
				taken(this);
				taken(mpa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_preimage_range_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLMap preimageRange(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_map_preimage_range_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLMap.build(ISLNative.isl_map_preimage_range_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_preimage_range_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLMap preimageRange(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_map_preimage_range_pw_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLMap.build(ISLNative.isl_map_preimage_range_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_product 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap product(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_product) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_product(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_domain_product 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap domainProduct(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_domain_product) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_domain_product(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_range_product 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap rangeProduct(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_range_product) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_range_product(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_flat_product 
	 * 
	 * @take this map2
	 * @generated
	**/
	public ISLMap flatProduct(ISLMap map2) {
		/*** PROTECTED REGION ID(isl_map_flat_product) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map2);
			try {
				res = ISLMap.build(ISLNative.isl_map_flat_product(getNativePtr(this), getNativePtr(map2)));
			} finally {
				taken(this);
				taken(map2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMap gist(ISLMap context) {
		/*** PROTECTED REGION ID(isl_map_gist) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMap.build(ISLNative.isl_map_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMap gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_map_gist_params) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMap.build(ISLNative.isl_map_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_gist_domain 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMap gistDomain(ISLSet context) {
		/*** PROTECTED REGION ID(isl_map_gist_domain) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMap.build(ISLNative.isl_map_gist_domain(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_gist_range 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMap gistRange(ISLSet context) {
		/*** PROTECTED REGION ID(isl_map_gist_range) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMap.build(ISLNative.isl_map_gist_range(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_partial_lexmin 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap partialLexMin(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_map_partial_lexmin) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_map_partial_lexmin(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_partial_lexmax 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap partialLexMax(ISLSet dom) {
		/*** PROTECTED REGION ID(isl_map_partial_lexmax) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_map_partial_lexmax(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap lexMin() {
		/*** PROTECTED REGION ID(isl_map_lexmin) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap lexMax() {
		/*** PROTECTED REGION ID(isl_map_lexmax) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lexmin_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff lexMinAsPWMultiAff() {
		/*** PROTECTED REGION ID(isl_map_lexmin_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_map_lexmin_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lexmax_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff lexMaxAsPWMultiAff() {
		/*** PROTECTED REGION ID(isl_map_lexmax_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_map_lexmax_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_range_simple_fixed_box_hull 
	 * 
	 * @generated
	**/
	public ISLFixedBox getRangeSimpleFixedBoxHull() {
		/*** PROTECTED REGION ID(isl_map_get_range_simple_fixed_box_hull) DISABLED START ***/
		ISLFixedBox res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLFixedBox.build(ISLNative.isl_map_get_range_simple_fixed_box_hull(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_range_stride_info 
	 * 
	 * @generated
	**/
	public ISLStrideInfo getRangeStrideInfo(int pos) {
		/*** PROTECTED REGION ID(isl_map_get_range_stride_info) DISABLED START ***/
		ISLStrideInfo res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLStrideInfo.build(ISLNative.isl_map_get_range_stride_info(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_get_basic_map_at 
	 * 
	 * @generated
	**/
	public ISLBasicMap getBasicMapAt(int pos) {
		/*** PROTECTED REGION ID(isl_map_get_basic_map_at) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicMap.build(ISLNative.isl_map_get_basic_map_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_numberof_basic_map 
	 * 
	 * @generated
	**/
	public int getNbBasicMaps() {
		/*** PROTECTED REGION ID(isl_map_numberof_basic_map) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_numberof_basic_map(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * clear_in_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap clearInputTupleName() {
		/*** PROTECTED REGION ID(clear_in_tuple_name) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.clear_in_tuple_name(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * clear_out_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap clearOutputTupleName() {
		/*** PROTECTED REGION ID(clear_out_tuple_name) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.clear_out_tuple_name(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
